import { EmployeeModel, MyEmployeeModel } from "./employee.model"
import { EvaluationCycleModel, MyEvaluationCycleModel } from "./evaluation-cycle.model"
import { MasfromEvaluationAssessment1Model, MyMasfromEvaluationAssessment1Model } from "./masfrom-evaluation-assessment1.model"
import { MyPLModel, PLModel } from "./pl.model"

export interface AppraisalFormModel {
    personalLevel: PLModel
    masfromEvaluationRoundModel: EvaluationCycleModel
    companyId: string
    fromDetail: string
    apsassessy: EmployeeModel
    apsassessyComment: string
    apsapprove1: EmployeeModel
    apsapprove2: EmployeeModel
    apsapprove3: EmployeeModel
    apsapprove4: EmployeeModel
    apsapprove5: EmployeeModel
    apsassessyStatus: string
    apsapprove1Status: string
    apsapprove2Status: string
    apsapprove3Status: string
    apsapprove4Status: string
    apsapprove5Status: string
    numberCheck1: number
    numberCheck2: number
    numberCheck3: number
    numberCheck4: number
    numberCheck5: number
    weightedTotal: number
    averageScore: number
    apsapprove1Comment: string
    apsapprove2Comment: string
    apsapprove3Comment: string
    apsapprove4Comment: string
    apsapprove5Comment: string
    evaluationResults: string
    sumEvaluationResults: string
    masfromEvaluationAssessment1lList: MasfromEvaluationAssessment1Model[]
}
export class MyAppraisalFormModel implements AppraisalFormModel {
    personalLevel: PLModel
    masfromEvaluationRoundModel: EvaluationCycleModel
    companyId: string
    fromDetail: string
    apsassessy: EmployeeModel
    apsassessyComment: string
    apsapprove1: EmployeeModel
    apsapprove2: EmployeeModel
    apsapprove3: EmployeeModel
    apsapprove4: EmployeeModel
    apsapprove5: EmployeeModel
    apsassessyStatus: string
    apsapprove1Status: string
    apsapprove2Status: string
    apsapprove3Status: string
    apsapprove4Status: string
    apsapprove5Status: string
    numberCheck1: number
    numberCheck2: number
    numberCheck3: number
    numberCheck4: number
    numberCheck5: number
    weightedTotal: number
    averageScore: number
    apsapprove1Comment: string
    apsapprove2Comment: string
    apsapprove3Comment: string
    apsapprove4Comment: string
    apsapprove5Comment: string
    evaluationResults: string
    sumEvaluationResults: string
    masfromEvaluationAssessment1lList: MasfromEvaluationAssessment1Model[]
    constructor(data?: Partial<AppraisalFormModel>) {
        this.personalLevel = new MyPLModel(data?.personalLevel)
        this.masfromEvaluationRoundModel = new MyEvaluationCycleModel(data?.masfromEvaluationRoundModel)
        this.companyId = data?.companyId || ""
        this.fromDetail = data?.fromDetail || ""
        this.apsassessyComment = data?.apsassessyComment || ""
        this.apsassessy = new MyEmployeeModel(data?.apsassessy)
        this.apsapprove1 = new MyEmployeeModel(data?.apsapprove1)
        this.apsapprove2 = new MyEmployeeModel(data?.apsapprove2)
        this.apsapprove3 = new MyEmployeeModel(data?.apsapprove3)
        this.apsapprove4 = new MyEmployeeModel(data?.apsapprove4)
        this.apsapprove5 = new MyEmployeeModel(data?.apsapprove5)
        this.apsassessyStatus = data?.apsassessyStatus || ""
        this.apsapprove1Status = data?.apsapprove1Status || ""
        this.apsapprove2Status = data?.apsapprove2Status || ""
        this.apsapprove3Status = data?.apsapprove3Status || ""
        this.apsapprove4Status = data?.apsapprove4Status || ""
        this.apsapprove5Status = data?.apsapprove5Status || ""
        this.numberCheck1 = data?.numberCheck1 ?? 0
        this.numberCheck2 = data?.numberCheck2 ?? 0
        this.numberCheck3 = data?.numberCheck3 ?? 0
        this.numberCheck4 = data?.numberCheck4 ?? 0
        this.numberCheck5 = data?.numberCheck5 ?? 0
        this.weightedTotal = data?.weightedTotal ?? 0
        this.averageScore = data?.averageScore ?? 0
        this.apsapprove1Comment = data?.apsapprove1Comment || ""
        this.apsapprove2Comment = data?.apsapprove2Comment || ""
        this.apsapprove3Comment = data?.apsapprove3Comment || ""
        this.apsapprove4Comment = data?.apsapprove4Comment || ""
        this.apsapprove5Comment = data?.apsapprove5Comment || ""
        this.evaluationResults = data?.evaluationResults || ""
        this.sumEvaluationResults = data?.sumEvaluationResults || ""
        this.masfromEvaluationAssessment1lList = data?.masfromEvaluationAssessment1lList?.map(x => new MyMasfromEvaluationAssessment1Model(x)) || []
    }
}

