import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';
import { PLModel } from '../model/pl.model';
import { AlertModel } from '../model/alert.model';
import { AppraisalModel } from '../model/appraisal.model';
import { AppraisalFormModel } from '../model/appraisal-form.model';
@Injectable({
  providedIn: 'root'
})
export class AppraisalService {
  api = "/appraisal"
  urlApi = environment.baseUrl + this.api
  constructor(private http: HttpClient) {
  }
  getFormCompentencyById(evaluationRoundId: string, apsassessy: string): Observable<AppraisalFormModel> {
    return this.http.get<AppraisalFormModel>(this.urlApi + "/competency/" + evaluationRoundId + "/" + apsassessy)
  }
  getCompetencyList(): Observable<AppraisalModel[]> {
    return this.http.get<AppraisalModel[]>(this.urlApi + "/competency/emp")
  }
  postCompetency(body: AppraisalFormModel): Observable<AlertModel> {
    return this.http.post<AlertModel>(this.urlApi + "/competency", body)
  }
}